<cfcomponent name="Person">

	<cfproperty name="FirstName" type="string" default="">
	<cfproperty name="LastName" type="string" default="">
	<cfproperty name="Age" type="numeric" default="">

	<cfscript>
		this.FirstName = "";
		this.LastName = "";
		this.Age = 33;
	</cfscript>

	<cffunction name="instance" access="remote" output="false"
				 returntype="flex_samples.RemoteObject.RemoteObjectSample.Person">
		
		<cfif IsDefined("Session.Person")>
			<cfset this = Session.Person>
		<cfelse>
			<cfset this.FirstName = "John">
			<cfset this.LastName = "Smith">
			<cfset this.Age = "33">
			
			<cfset Session.Person = this>
		</cfif>
		
		<cfreturn this>
	</cffunction>
	
	<cffunction name="update" access="remote" output="false" returntype="Any">
		<cfargument name="person" required="true" type="any">
		
		<cfif CompareNoCase(GetMetaData(arguments.person).name, "flex_samples.RemoteObject.RemoteObjectSample.Person") eq 0>
			<cfset Session.Person = arguments.person>
		<cfelse>
			<cfset p = CreateObject("component", "flex_samples.RemoteObject.RemoteObjectSample.Person")>
			<cfset p.FirstName = arguments.person.FirstName>
			<cfset p.LastName = arguments.person.LastName>
			<cfset p.Age = arguments.person.Age>

			<cfset Session.Person = p>
		</cfif>
		
		<cfreturn Session>
	</cffunction>

</cfcomponent>